// ANNForecastAppAgent.h

// ANNForecastAppAgent inherits from BasicSumAgent and follows ForecastingAgent
// estimates of future prices
// the agent buys/sells if the forecasting index is > or < than 1; if ==1 doesn't
// act; we can have also an inactivityRange, so more exacltly the agent acts
// only if the forecasting index is > 1+aNNInactivityRange or <1-aNNInactivityRange

// this kind of agents uses also a probability of acting in each day defined by the
// aNNForecastAppAgentActDailyProb value

// anyway, in case of price sliding below the floor price, a buying behavior
// prevails

#import <random.h>
#import "BasicSumAgent.h"
#import "RandomRuleMaster.h"
#import "ForecastingAgent.h"

@interface ANNForecastAppAgent: BasicSumAgent
{
  float aNNInactivityRange, aNNForecastAppAgentActDailyProb;

  int randomBookNumber;

  RandomRuleMaster * ruleMaster;
  ForecastingAgent * forecastingAgent;
  Book * aBook;
  id <UniformDoubleDist> myUniformDblRand;
  id <Index> forecastingAgentArrayIndex;

}

- setANNInactivityRange: (float) r andANNForecastAppAgentActDailyProb: (float) p;
- setRuleMaster: r;
//- setForecastingAgent;
-(float) chooseBuySellSwitch: (int) m with: (float) a and: (float) aN;
- setMyUniformDblRand: u; // an ad hoc distribution, see comment in
                          // modelSwarm.h and .m

- setForecastingAgentArrayIndex: i;


- act0; // acting - placing buy or sell orders - before opening
- act1;  // placing buy or sell orders

@end
