// ArbitrageurAgent.m  

#import "ArbitrageurAgent.h"
#import "Book.h"
#import "IndexCalculator.h"

@implementation ArbitrageurAgent

- setArbitrageurOperatingInterval: (float) i
{
  arbitrageurOperatingInterval=i;
  return self;
}

- setArbitrageurGain: (int) i
{
  arbitrageurGain=i;
  return self;
}

- setArbitrageurOperatingIntervalFixed: (int) i
{
  arbitrageurOperatingIntervalFixed=i;
  return self;
}

- setIndexCalculator: t
{
  indexCalculator = t;
  return self;
}
 

- act0
{
    int i;
    // clearing executedPrices
    executedPriceCount=0;
    for (i=0;i<maxOrderQuantity2;i++) [executedPrices R:i C:0 setFrom:0];
   return self;
}

 // Acting 
- act1
{
   int i; 
   Book * futureBook;

   [bookArrayIndex setOffset: bookNumber-1];
   futureBook=[bookArrayIndex get]; 
   
   indexValue=[indexCalculator  getIndexValue];
    
   realFuturePrice= [self  getPrice2: bookNumber];   

   //indexSpread=(((IndexValue-realFuturePrice)/IndexValue)+((IndexValue-realFuturePrice)/realFuturePrice))/2;    
   
   //choose short or long position on future and shares
   
   if(indexValue>realFuturePrice) {buySellSwitchFuture=1; buySellSwitchShares=-1; }
   else if(indexValue<realFuturePrice) {buySellSwitchFuture=-1; buySellSwitchShares=1; }
   else {buySellSwitchFuture=0; buySellSwitchShares=0; 
         if(printing==1)printf("Arbitrageur doesn't play: there isn't no  spread \n");
        }
   

   //check counterpart of shares
   
   if (buySellSwitchShares!=0){
   for (i=1;i<bookNumber;i++)
    {        
      Book * aBook;
      [bookArrayIndex setOffset: i-1];
      aBook=[bookArrayIndex get];     
      if (buySellSwitchShares==-1){
         if ([aBook getBuyOrderNumber]==0.0){buySellSwitchShares=0;
           if(printing==1)printf("Arbitrageur doesn't play: there isn't counterpart for selling book %3d.\n",i);
           }
      }else if(buySellSwitchShares==1){
         if ([aBook getSellOrderNumber]==0.0){buySellSwitchShares=0;
           if(printing==1)printf("Arbitrageur doesn't play: there isn't counterpart for buying book %3d.\n",i);
           }         
      }else{buySellSwitchShares=0;}
      
    }}

    //check counterpart of index

      if (buySellSwitchFuture==-1){
         if ([futureBook getBuyOrderNumber]==0.0){buySellSwitchFuture=0;
           if(printing==1)printf("Arbitrageur doesn't play: there isn't counterpart for selling Index.\n");
           }                  
      }else if(buySellSwitchFuture==1){
         if ([futureBook getSellOrderNumber]==0.0){buySellSwitchFuture=0;
           if(printing==1)printf("Arbitrageur doesn't play: there isn't counterpart for buying Index.\n");
           }                  
      }else{buySellSwitchFuture=0;}
 

// we calculate if arbitrating actions produce a sure gain for arbitrageur agent

    sumOfPrice=0.0;

// here we use a fixed gain (arbitrageurOperatingIntervalFixed==1)
    
    if ((arbitrageurGain==1)&&(arbitrageurOperatingIntervalFixed==1)) {
      if ((buySellSwitchFuture==1)&&(buySellSwitchShares==-1)){


	if((indexValue - realFuturePrice)>arbitrageurOperatingInterval){buySellSwitchFuture=1; buySellSwitchShares=-1; }
	else {buySellSwitchFuture=0; buySellSwitchShares=0; 
		if(printing==1)printf("Arbitrageur doesn't play: there isn't no  spread\n");
	}
           
      }else if((buySellSwitchFuture==-1)&&(buySellSwitchShares==1)){

	if((realFuturePrice - indexValue)>arbitrageurOperatingInterval){buySellSwitchFuture=-1; buySellSwitchShares=1; }
	else {buySellSwitchFuture=0; buySellSwitchShares=0; 
		if(printing==1)printf("Arbitrageur doesn't play: there isn't no  spread\n");
	}
                      
      }else{buySellSwitchFuture=0;}     
    }

// here we use a gain expressed as a ratio of future to index (arbitrageurOperatingIntervalFixed==0)

  if ((arbitrageurGain==1)&&(arbitrageurOperatingIntervalFixed==0)) {
      if ((buySellSwitchFuture==1)&&(buySellSwitchShares==-1)){
           for (i=1;i<bookNumber;i++)
	     {        
	       Book * aBook;
	       [bookArrayIndex setOffset: i-1];
	       aBook=[bookArrayIndex get]; 
               sumOfPrice+=[aBook  getAskPrice];                
             }  
           newIndexValue=sumOfPrice/(bookNumber-1);
           price=[futureBook  getBidPrice];  
           futureSpread=(((newIndexValue-price)/newIndexValue)+((newIndexValue-price)/price))/2;    
           
           if(futureSpread>=arbitrageurOperatingInterval) {buySellSwitchFuture=1; buySellSwitchShares=-1; }	   
           else {buySellSwitchFuture=0; buySellSwitchShares=0;
                if(printing==1)printf("Arbitrageur doesn't play: there isn't no such spread (%5.3f %5.3f).\n",futureSpread, indexSpread);
                }
           
      }else if((buySellSwitchFuture==-1)&&(buySellSwitchShares==1)){
           for (i=1;i<bookNumber;i++)
	     {        
	       Book * aBook;
	       [bookArrayIndex setOffset: i-1];	        
	       aBook=[bookArrayIndex get]; 
               sumOfPrice+=[aBook  getBidPrice]; 
             }  
           newIndexValue=sumOfPrice/(bookNumber-1);
           price=[futureBook  getAskPrice];  
           futureSpread=(((newIndexValue-price)/newIndexValue)+((newIndexValue-price)/price))/2;    
           
           if(futureSpread<=-1*arbitrageurOperatingInterval) {buySellSwitchFuture=-1; buySellSwitchShares=1; }           
           else {buySellSwitchFuture=0; buySellSwitchShares=0;
                if(printing==1)printf("Arbitrageur doesn't play: there isn't no such spread (%5.3f %5.3f).\n",futureSpread, indexSpread);
                }
           
      }else{buySellSwitchFuture=0;}     
    }

    
     //get the prices and insert orders
     
      if ((buySellSwitchFuture==1)&&(buySellSwitchShares==-1)){
           for (i=1;i<bookNumber;i++)
	     {        
	       Book * aBook;
	       [bookArrayIndex setOffset: i-1];
	       aBook=[bookArrayIndex get]; 
               price=-1*[aBook  getAskPrice]; 
               [self setOrderFromAgent2: i ofAgent: number atPrice:  price];
             }  
           price=[futureBook  getBidPrice];  
           [self setOrderFromAgent2: bookNumber ofAgent: number atPrice:  price];
      }else if((buySellSwitchFuture==-1)&&(buySellSwitchShares==1)){
           for (i=1;i<bookNumber;i++)
	     {        
	       Book * aBook;
	       [bookArrayIndex setOffset: i-1];	        
	       aBook=[bookArrayIndex get]; 
               price=[aBook  getBidPrice]; 
               [self setOrderFromAgent2: i ofAgent: number atPrice:  price]; 
             }  

           price=-1*[futureBook  getAskPrice];  
           [self setOrderFromAgent2: bookNumber ofAgent: number atPrice:  price];
      }else{buySellSwitchFuture=0;}     
     

   return self;
}

@end
