// AvatarAgent.m

#import "AvatarAgent.h"
#include <stdarg.h>
#include <time.h>


@implementation AvatarAgent

- setContinuosMarket: (int) n
{
  continuosMarket = n;
  return self;
}

- setPenalty: (int) p
{
  humanPenalty = p;
  return self;
}

- createEnd
{

   [super createEnd];
   currentDay=0;

   // keeping data for avatar agents

   if (continuosMarket==1){
     float oldLiquidity, shares;
     int k;
     FILE * wealthFile;

     char  webWealthFileName [40];
     sprintf(webWealthFileName,"avatardata/%d.wealth",number);
     wealthFile = fopen (webWealthFileName,"r");

     if (wealthFile != NULL) {
        fscanf(wealthFile,"%f\n", &oldAgentWealthAtMeanDailyPrice);
        fscanf(wealthFile,"%f\n", &oldLiquidity);

		agentWealthAtMeanDailyPrice=oldAgentWealthAtMeanDailyPrice;
        liquidityQuantity=oldLiquidity;


        k=1;
        while (fscanf(wealthFile,"%f\n", &shares) != EOF)
          {
          shareQuantityVector[k]=shares;
          k++;
          }
      }else{liquidityQuantity=0;}

   }

   return self;
}


  // communicate the event to the Avatars
- communicateEvent1
{
  FILE * tmpFile;
  FILE * mpFile;
  char c;
  int tmpOpened;

  char  webMessageFileName [40];
  sprintf(webMessageFileName,"avatardata/%d.msg",number);

  time_t t;
  time (&t);

  tmpOpened=0;
  rename(webMessageFileName,"tempFile");

  mpFile = fopen (webMessageFileName,"a");

  fprintf(mpFile,"<font color=\"\x23 FF0000\">%s : very negative event</font><br>\n", ctime(&t));

  if( (tmpFile = fopen ("tempFile","r")) ){
     tmpOpened=1;
     while ((c = fgetc(tmpFile)) != EOF)
        fputc(c, mpFile);

  fclose(mpFile);

  if (tmpOpened==1){
     fclose(tmpFile);
     remove("tempFile");
  }
  }

 return self;
}


- communicateEvent2
{
  FILE * tmpFile;
  FILE * mpFile;
  char c;
  int tmpOpened;

  char  webMessageFileName [40];
  sprintf(webMessageFileName,"avatardata/%d.msg",number);

  time_t t;
  time (&t);

  tmpOpened=0;
  rename(webMessageFileName,"tempFile");

  mpFile = fopen (webMessageFileName,"a");

  fprintf(mpFile,"<font color=\"\x23 FF9900\">%s : negative event</font><br>\n", ctime(&t));

  if( (tmpFile = fopen ("tempFile","r")) ){
     tmpOpened=1;
     while ((c = fgetc(tmpFile)) != EOF)
        fputc(c, mpFile);

  fclose(mpFile);

  if (tmpOpened==1){
     fclose(tmpFile);
     remove("tempFile");
  }
  }

 return self;
}

- communicateEvent3
{
  FILE * tmpFile;
  FILE * mpFile;
  char c;
  int tmpOpened;

  char  webMessageFileName [40];
  sprintf(webMessageFileName,"avatardata/%d.msg",number);

  time_t t;
  time (&t);

  tmpOpened=0;
  rename(webMessageFileName,"tempFile");

  mpFile = fopen (webMessageFileName,"a");

  fprintf(mpFile,"<font color=\"\x23 33FF00\">%s : positive event</font><br>\n", ctime(&t));

  if( (tmpFile = fopen ("tempFile","r")) ){
     tmpOpened=1;
     while ((c = fgetc(tmpFile)) != EOF)
        fputc(c, mpFile);

  fclose(mpFile);

  if (tmpOpened==1){
     fclose(tmpFile);
     remove("tempFile");
  }
  }

 return self;
}

- communicateEvent4
{
  FILE * tmpFile;
  FILE * mpFile;
  char c;
  int tmpOpened;

  char  webMessageFileName [40];
  sprintf(webMessageFileName,"avatardata/%d.msg",number);

  time_t t;
  time (&t);

  tmpOpened=0;
  rename(webMessageFileName,"tempFile");

  mpFile = fopen (webMessageFileName,"a");

  fprintf(mpFile,"<font color=\"\x23 0099FF\">%s : very positive event</font><br>\n", ctime(&t));

  if( (tmpFile = fopen ("tempFile","r")) ){
     tmpOpened=1;
     while ((c = fgetc(tmpFile)) != EOF)
        fputc(c, mpFile);

  fclose(mpFile);

  if (tmpOpened==1){
     fclose(tmpFile);
     remove("tempFile");
  }
  }

 return self;
}


- orderConfirmationFrom: (int) bn atPrice:(float) p
{

  FILE * tmpFile;
  FILE * mpFile;

  char c;
  int tmpOpened;

  char  webMessageFileName [40];
  sprintf(webMessageFileName,"avatardata/%d.msg",number);

  time_t t;
  time (&t);

  tmpOpened=0;
  rename(webMessageFileName,"tempFile");

  mpFile = fopen (webMessageFileName,"a");

  fprintf(mpFile,"Order Executed on %s at price %7.4f on Book %3d<br>\n",ctime(&t),p,bn);

  if( (tmpFile = fopen ("tempFile","r")) ){
     tmpOpened=1;
     while ((c = fgetc(tmpFile)) != EOF)
        fputc(c, mpFile);
  }

  fclose(mpFile);

  if (tmpOpened==1){
     fclose(tmpFile);
     remove("tempFile");
  }

  return self;
}



  // Acting before opening
- act0
{
    float BS1, p1, q1;
     int i, b1;

  char  webdataFileName [40];
  sprintf(webdataFileName,"avatardata/%d.dat",number);

    FILE * pFile;
    pFile = fopen (webdataFileName,"r");

    if (pFile != NULL) {
		actingBeforeOpening=1;

        while (fscanf(pFile,"%f,%f,%f,%d", &BS1, &p1, &q1, &b1) != EOF)
          {
		  if (p1 != 0) {price = BS1 * p1;}

		  if (maxOrderQuantity==1) iMax=1;
		  else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];

		  for (i=1;i<=iMax;i++)
		  [self setOrderBeforeOpeningFromAgent2: b1 ofAgent:  number atPrice:  price];

		  if (printing==1)  printf("Human play in auction at price %f on book #%d\n",price,b1);
          }

		fclose(pFile);
		remove(webdataFileName);
	}else{
		actingBeforeOpening=0;

		price = 0.0;
     b1=1;
if (printing==1)  printf("Human doesn't play in auction opening\n");

   if (maxOrderQuantity==1) iMax=1;
       else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)

      [self setOrderBeforeOpeningFromAgent2: b1 ofAgent:  number atPrice:  price];
      }

return self;
}



  // acting in the market
- act1
{
	float BS, p, q;
	char  webdataFileName [40];
	sprintf(webdataFileName,"avatardata/%d.dat",number);
    int i, b2;

	// the agent has operated before opening or has already paly at the time
/*	if (actingBeforeOpening==1 || actingAtTheTime==1) {
		if (printing==1) printf("Human doesn't play: has already played today\n");
		return self;
	}
*/
    FILE * ppFile;
    ppFile = fopen (webdataFileName,"r");
    if (ppFile != NULL) {
        while (fscanf(ppFile,"%f,%f,%f,%d", &BS, &p, &q, &b2) != EOF)
          {
	      if (p != 0) {price = BS * p;}

		  if (maxOrderQuantity==1) iMax=1;
		  else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];

		  for (i=1;i<=iMax;i++)
      	  [self setOrderFromAgent2: b2 ofAgent: number atPrice:  price];

		  if (printing==1)  printf("Human play at price %f on book #%d\n",price,b2);
          }

 		actingAtTheTime=1;
		fclose(ppFile);
		remove(webdataFileName);
    }else{
	    price = 0.0;
	    b2=1;
		if (printing==1)  printf("Human doesn't play\n");
        if (maxOrderQuantity==1) iMax=1;
        else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];

		for (i=1;i<=iMax;i++)
		[self setOrderFromAgent2: b2 ofAgent: number atPrice:  price];
    }



   return self;
}


- act2
{
  int k;
  FILE * wealthFile;
  FILE * wealthHistoryFile;

  lowTransactionCost  = 0.01; //agg
  highTransactionCost = 0.65; //agg
  numberOfTransaction = 10;   //agg


  [super act2];

  //if (executedPriceCount <= numberOfTransaction){ //agg
	  agentWealthAtMeanDailyPrice=agentWealthAtMeanDailyPrice - lowTransactionCost*executedPriceCount; //agg
//	  }else{ //agg
//	  agentWealthAtMeanDailyPrice=agentWealthAtMeanDailyPrice - highTransactionCost*executedPriceCount; //agg;
//  } //agg



  currentDay++;

  char  webWealthFileName [40];
  sprintf(webWealthFileName,"avatardata/%d.wealth",number);
  wealthFile = fopen (webWealthFileName,"w");

  fprintf(wealthFile,"%10.4f\n",agentWealthAtMeanDailyPrice);
  fprintf(wealthFile,"%10.4f\n",liquidityQuantity);


  for (k=1;k<=bookNumber;k++){
	fprintf(wealthFile,"%10.4f\n",shareQuantityVector[k]);
  }

  fclose(wealthFile);

  char  webWealthHistoryFileName [40];
  sprintf(webWealthHistoryFileName,"avatardata/%d.wealthistory",number);
  wealthHistoryFile = fopen (webWealthHistoryFileName,"a");

  fprintf(wealthHistoryFile,"%5d\t%10.4f\n",currentDay,agentWealthAtMeanDailyPrice);
  fclose(wealthHistoryFile);

  if(humanPenalty!=0)[self penaltyAccounting];

  return self;
}


- penaltyAccounting
{

  FILE * penaltyFile;
  FILE * transactionFile;
   // penalty for human
   // penalty for class experiment
  if(humanPenalty==1){

	char  penaltyFileName [40];
	sprintf(penaltyFileName,"avatardata/%d.penalty",number);

     if ((penaltyFile = fopen (penaltyFileName,"r")) != NULL) {
        fscanf(penaltyFile,"%f\n", &oldPenalty);
        fclose(penaltyFile);
	}  else {
		oldPenalty=0.0;
	}
	penaltyFile = fopen (penaltyFileName,"w");

	if(executedPriceCount<=0){
		penalty=-3+oldPenalty;
	}else if(executedPriceCount==1){
		penalty=-2+oldPenalty;
	}else if(executedPriceCount==2){
		penalty=-1+oldPenalty;
	}else if(executedPriceCount>=3){
		penalty=oldPenalty;
	}else{
		penalty=oldPenalty;
	}
	fprintf(penaltyFile,"%10.4f",penalty);
	fclose(penaltyFile);

  // penalty for online experiment

  }else if(humanPenalty==2){
	char  transactionFileName [40];
	sprintf(transactionFileName,"avatardata/%d.transaction",number);

     if ((transactionFile = fopen (transactionFileName,"r")) != NULL) {
        fscanf(transactionFile,"%f\n", &oldTransaction);
	    fclose(transactionFile);
	}  else {
		oldTransaction=0.0;
	}


	transactionFile = fopen (transactionFileName,"w");

	transaction=executedPriceCount+oldTransaction;
/*
	if(executedPriceCount<=0){
		transaction=-3+oldTransaction;
	}else if(executedPriceCount==1){
		transaction=-2+oldTransaction;
	}else if(executedPriceCount==2){
		transaction=-1+oldTransaction;
	}else if(executedPriceCount>=3){
		transaction=oldTransaction;
	}else{
		transaction=oldTransaction;
	}*/
	fprintf(transactionFile,"%10.4f",transaction);
	fclose(transactionFile);
  }
  return self;
}

- onlineExperimentPenaltyAccounting
{
	FILE * penaltyFile;
    FILE * transactionFile;
	// read the number of transaction at this moment
	char  transactionFileName [40];
	sprintf(transactionFileName,"avatardata/%d.transaction",number);

     if ((transactionFile = fopen (transactionFileName,"r")) != NULL) {
        fscanf(transactionFile,"%f\n", &oldTransaction);
	    fclose(transactionFile);
	}  else {
		oldTransaction=0.0;
	}


	// set to zero the number of transaction
	transactionFile = fopen (transactionFileName,"w");
	fprintf(transactionFile,"0.0");
	fclose(transactionFile);

	// read actual penalty
	char  penaltyFileName [40];
	sprintf(penaltyFileName,"avatardata/%d.penalty",number);


     if ((penaltyFile = fopen (penaltyFileName,"r")) != NULL) {
        fscanf(penaltyFile,"%f\n", &oldPenalty);
        fclose(penaltyFile);
	}  else {
		oldPenalty=0.0;
	}

	// write new penalty
	penaltyFile = fopen (penaltyFileName,"w");

	if(oldTransaction<=0){
		penalty=-3+oldPenalty;
	}else if(oldTransaction==1){
		penalty=-2+oldPenalty;
	}else if(oldTransaction==2){
		penalty=-1+oldPenalty;
	}else if(oldTransaction>=3){
		penalty=oldPenalty;
	}else{
		penalty=oldPenalty;
	}
	fprintf(penaltyFile,"%10.4f",penalty);
	fclose(penaltyFile);

  return self;


}

@end





