// **********************************
// from basic code to apps: keep this file unchanged
// (this warning comes from bp-ct-1.1, i.e the original application containing it)
// the file is modified here to inherit from BasicSumAgent
// the definition of the interface is here delayed to the specific agent
// **********************************

// BPCTAgent.h

#import "BasicSumAgent.h"
#import <simtools.h>  // necessary to invoke OutFile protocol
#import "Matrix.h"
#import "BPCTRuleMaster.h" // the source of the rules determining the agent
                           // behavior
#import "BPCTPriceRuleMaster.h"
#import "BPCTDataWarehouse.h"
#import "BPCTInterface.h"

@interface BPCTAgent: BasicSumAgent
{

  BPCTInterface * myInterface;
                         // in ModelSwarmn the assignement is that of the
                         // specific interface used in the specific agent object
                         // inheriting from this one (where it is newly declared
                         // as specific interface, with the same address
  BPCTRuleMaster    * ruleMaster;
  BPCTPriceRuleMaster    * priceRuleMaster;
  BPCTDataWarehouse * myDataWarehouse;

  int inputNodeNumber, hiddenNodeNumber, outputNodeNumber,
  patternNumberInVerificationSet,
  agentsAreDisplayingData, readWeightsFromFile;
  float backPropagationErrorInVerificationSet,
        proportionalErrorInVerificationSet,
        backPropagationErrorInTrainingSet,
        proportionalErrorInTrainingSet;
  Matrix * outputVerificationMatrix, * targetVerificationMatrix, * minmax;


}

- createEnd;

- setNumber: (int) n andSetReadWeightsFromFile: (int) rw;
- setRuleMaster: rm;
- setPriceRuleMaster: rm;
- setDataWarehouse: dw;
- setDisplayDataWhileRunning: (int) d;
- setInterface: inf;

- getInterface;
- getDataWarehouse;
- (int) getNumber;

- step1; // see BPCTAgent.m
- step2;
- step3;

-(float) getBackPropagationErrorInVerificationSet;
-(float) getProportionalErrorInVerificationSet;

-(float) getBackPropagationErrorInTrainingSet;
-(float) getProportionalErrorInTrainingSet;
-(int) getBPCTPatternNumberInVerificationSet;

- save;  // to save the weights

@end




