// an operating BPCTAgent in the sum context
// this one, following its AgentAInterface, learns to determine
// the mean of the last three mean prices

// BPCTAgentB.m

#import "BPCTAgentB.h"

@implementation BPCTAgentB

- setSpecificInterface: inf
{
  mySpecificInterface = inf;
  return self;
}

- createEnd
{
   [super createEnd];

   // this is not a polite solution, from the object oriented programming
   // point of view, but here we have to communicate variables of
   // BasicSumAgent (parent of BPCTAgentB) to BPCTAgentBInterface, which
   // knows only the address of the BPCTDataWarehouse, which in turn don't
   // know the agent address; so ... we send some pointer to the
   // BPCTDataWarehouse ...
   [myDataWarehouse
     setAccountingVariableAdresses1LiquidityQuantity: &liquidityQuantity
			and2ShareQuantity:      &shareQuantity
			and3ShareValue:         &shareValueAtMeanDailyPrice
			and4AgentWealth:        &agentWealthAtMeanDailyPrice
                        and5MeanOperatingPrice: &meanOperatingPrice];

   return self;
}

- act0
{
  float lastPrice, choice;
  int i;

   [self step1]; // forward step of the ANN of our CT mechanism
   choice= [mySpecificInterface getBuySell_out]; // >0 buy, <0 sell, =0 nothing

   lastPrice=[theBook getPrice];
   price    =[priceRuleMaster getPriceBeforeOpening: lastPrice];
   if (price!=0) actingBeforeOpening=1;

   if(printing==7)printf
           ("act0 choice %f lastPrice %f price %f\n",choice,lastPrice,price);

   // applying the choice made by CT output (the book wait for a positive
   // price as a buying signal, a negative price as a selling signal; 0
   // means: do nothing

   if (choice==0) price=0;
   if (choice< 0) price*=-1; // if price is 0 from priceRuleMaster, after
   // this operation it can appear in probe as -0, but internally (tested in
   // if) is ==0

   // choice also indicates the number of buy or sell orders; NB it is a
   // non integer value
   // first of all we check the max
   choice=fabs(choice); if (choice>maxOrderQuantity)choice=maxOrderQuantity;
   for (i=0;i<choice;i++)
	  // if (n-1)<choice<=n the loop is repeated n times; if choice=0
	  // the book doesn't act, but anyway also the loop isn't executed
   [theBook setOrderBeforeOpeningFromAgent: number atPrice: price];

  return self;
}

- act1
{
  float lastPrice, choice;
  int i;

   // the agent has operated before opening
   if (actingBeforeOpening==1) return self;

   choice= [mySpecificInterface getBuySell_out]; // >0 buy, <0 sell, =0 nothing

   lastPrice=[theBook getPrice];
   price=[priceRuleMaster getPrice: lastPrice];

   if(printing==7)printf
           ("act1 choice %f lastPrice %f price %f\n",choice,lastPrice,price);

   // applying the choice made by CT output (the book wait for a positive
   // price as a buying signal, a negative price as a selling signal; 0
   // means: do nothing

   if (choice==0) price=0;
   if (choice< 0) price*=-1; // if price is 0 from priceRuleMaster, after
   // this operation can display in probe as -0, but internally (tested in if)
   // is ==0

   // choice also indicates the number of buy or sell orders; NB it is a
   // non integer value
   // first of all we check the max
   choice=fabs(choice); if (choice>maxOrderQuantity)choice=maxOrderQuantity;
   for (i=0;i<choice;i++)
	  // if (n-1)<choice<=n the loop is repeated n times; if choice=0
	  // the book doesn't act, but anyway also the loop isn't executed
   [theBook setOrderFromAgent: number atPrice: price];

  return self;
}

- act2
{
  [super act2];

  [self step2]; // step2 is done after [self act2] to use accounting results
                // in BPCT target building
  [self step3];

  return self;
}

@end




