// **********************************
// from basic code to apps: changing lines are delimited with
//                                             // +++++++ start
//                                             // +++++++ end
// (this warning comes from bp-ct-1.1, i.e the original application containing 
// this file)
// **********************************

// BPCTAgentBInterface.h 

#import "BPCTInterface.h" // see headers imported by BPCTInterface.h
#import "ForecastingAgent.h"

@interface BPCTAgentBInterface: BPCTInterface
{
  ForecastingAgent * forecastingAgent;

// +++++++ start

  // CT inputs and outputs
  float bPCTLiquidityQuantity, bPCTShareQuantity, buySell, 
        bPCTClosingPriceWealth, bPCTForecastedPriceWealth;
// +++++++ end

}

- createEnd;

  // the following methods are strictly related to the meaning the problem
  // data to which we are applying our neural network have

  // so, for each application, we have to modify them if we want to display
  // agent data or operate with them in a CT way

// +++++++ start
- setForecastingAgent: f;

- (float) getMeanPrice5;
          // meanPrice5 (5 stays for t-5, where t is 'today')
          // is the 1st input
- (float) getMeanPrice4;
          // meanPrice4 (4 stays for t-4, where t is 'today')
          // is the 2nd input
- (float) getMeanPrice3;
          // meanPrice3 (3 stays for t-3, where t is 'today')
          // is the 3th input
- (float) getMeanPrice2;
          // meanPrice2 (2 stays for t-2, where t is 'today')
          // is the 4th input
- (float) getMeanPrice1;
          // meanPrice1 (1 stays for t-1, where t is 'today')
          // is the 5th input
- (float) getPreviousDayLiquidityQuantity;
          // previousDayLiquitityQuantity, corresponding to 
          // liquidityQuantity_target of the previous day, 
          // is the 6th input
- (float) getPreviousDayShareQuantity;
          // previousDayShareQuantity, corresponding to 
          // shareQuantity_target of the previous day, 
          // is the 8th input
- (float) getForecastingIndex;
          // forecastingIndex, obtained from the forecastingAgent,
          // is the 9th input

- (float) getLiquidityQuantity_out;
          // liquidityQuantity_out         is the output of the 1st effect
- (float) getLiquidityQuantity_target;
          // liquidityQuantity_target      is the target of the 1st effect
- (float) getShareQuantity_out;
          // shareQuantity_out             is the output of the 2nd effect
- (float) getShareQuantity_target;
          // shareQuantity_target          is the target of the 2nd effect
- (float) getClosingPriceWealth_out;
          // closingPriceWealth_out        is the output of the 3th effect
- (float) getClosingPriceWealth_target;
          // closingPriceWealt_target      is the target of the 3th effect
- (float) getForecastedPriceWealth_out;
          // forecastedPriceWealth_out     is the output of the 4th effect
- (float) getForecastedPriceWealth_target;
          // forecastedPriceWealth_target  is the target of the 4th effect
- (float) getBuySell_out;
          // buySell_out                   is the output of the 1st action
          // + buy; - sell
- (float) getBuySell_target;
          // buySell_target                is the target of the 1st action
          // + buy; - sell
// +++++++ end

  // the following methods override those of Interface.h, which
  // are left void in Interface.m


- setCT_Inputs;
- setCT_Targets;

@end
