// **********************************
// from basic code to apps: keep this file unchanged
// (this warning comes from bp-ct-1.1, i.e the original application containing
// this file)
// the file is modified here to use an ad hoc random distribution
// and to set adresses of accounting variables from the agent
// added also initDone and its get
// the main modification is the introduction of createBegin and of the methods
// necessary to modify 'on the fly' the minmax matrix
// **********************************

// BPCTDataWarehouse.h 
// this is the portion of the code where the data related to
// the neural network structure are stored; each has the address
// of its instance of DataWarehouse

#import <objectbase/SwarmObject.h>
#import <simtools.h>  // necessary to invoke InFile protocol
#import <random.h>
#import "Matrix.h"

@interface BPCTDataWarehouse: SwarmObject
{
  int inputNodeNumber, inputNodeNumber1,
      hiddenNodeNumber, hiddenNodeNumber1, outputNodeNumber,
      patternNumberInVerificationSet, patternNumberInTrainingSet,
      epochNumberInEachTrainingCycle, initDone;
  float weightRange, eps, alpha;
  int usingRandomOrderInLearning,
      longTermLearningInCT_OnlyWithCompleteTrainingSet,
      useOutputsAsTargetsInCT_RelearningScheme;

  Matrix * outputTrainingMatrix,     * targetTrainingMatrix,
         * dataTrainingMatrix, 
         * outputVerificationMatrix, * targetVerificationMatrix, 
         * dataVerificationMatrix,
         * minmax,
         * wih, * dwih, * who, * dwho,
         * inputLayer, * hiddenLayer, * outputLayer, * deltaOut,
         * hiddenLayerTransFuncDerivatives, * outputLayerTransFuncDerivatives;
  char * verificationFileName, * trainingFileName, * minmaxFileName,
       * initValuesFileName;
  id <InFile> verificationSet;
  id <InFile> trainingSet;
  id <InFile> minmaxSet;
  id <InFile> initValues;
  id <UniformDoubleDist> myUniformDblRand;

  float * liquidityQuantity, * shareQuantity, 
        * shareValueAtMeanDailyPrice, * agentWealthAtMeanDailyPrice,
        * meanOperatingPrice;

  int * genericIntVariableAddress;
  float * genericFloatVariableAddress;
  int minmaxRowToBeModifiedFromInt, minmaxRowToBeModifiedFromFloat; 
}

+ createBegin: aZone;
- createEnd;

// to modify minmax contents "on the fly" (one row from int and another one
// from float)
- setMinmaxRowToBeModifiedFromInt: (int) r 
                          usingGenericIntVariableAddress: (int *) a;
- setMinmaxRowToBeModifiedFromFloat: (int) r 
                          usingGenericFloatVariableAddress: (float *) a;

- setMyUniformDblRand: u; // an ad hoc distribution, see comment in 
                          // modelSwarm.h and .m
- setVerificationFileName: (char *) fn1   andTrainingFileName: (char *) fn2
            andMinmaxName: (char *) fn3 andInitValuesFileName: (char *) fn4;

- setInputNodeNumber: (int) ni andHiddenNodeNumber: (int) nh
                               andOutputNodeNumber: (int) no
                               andPatternNumberInVerificationSet: (int) pn1
                               andPatternNumberInTrainingSet:     (int) pn2
                               andEpochNumberInEachTrainingCycle: (int) cn;

- setBackPropagationParametersWeightRange: (float) wr eps: (float) e
                    alpha: (float) a
                    andWithOrderInLearning: (int) o
                    andLongTermLearningInCT: (int) lt
                    andUseOutputsAsTargetsInCT: (int) uo;

- readWeightsFromFileOfAgentNumber: (int) n;

// this is not a polite solution, from the object oriented programming
// point of view, but here we have to communicate variables of 
// BasicSumAgent (parent of BPCTAgentA) to BPCTAgentAInterface, which
// knows only the address of the BPCTDataWarehouse, which in turn don't
// know the agent address; so ... we send some pointer from the agent
- setAccountingVariableAdresses1LiquidityQuantity: (float *) l
				and2ShareQuantity: (float *) sq
				   and3ShareValue: (float *) sv
				  and4AgentWealth: (float *) w
                           and5MeanOperatingPrice: (float *) mop;
- (float) getAgentLiquidityQuantity;
- (float) getAgentShareQuantity;
- (float) getAgentShareValueAtMeanDailyPrice;
- (float) getAgentWealthAtMeanDailyPrice;
- (float) getAgentMeanOperatingPrice;

-(int) getInputNodeNumber;
-(int) getHiddenNodeNumber;
-(int) getOutputNodeNumber;
-(int) getPatternNumberInVerificationSet;
-(int) getPatternNumberInTrainingSet;
-(int) getEpochNumberInEachTrainingCycle;

- getOutputVerificationMatrix;
- getTargetVerificationMatrix;
- getDataVerificationMatrix;
- getOutputTrainingMatrix;
- getTargetTrainingMatrix;
- getDataTrainingMatrix;
- getMinmax;

- getInputLayer;
- getHiddenLayer;
- getHiddenLayerTransFuncDerivatives;
- getOutputLayer;
- getOutputLayerTransFuncDerivatives;
- getDeltaOut;

- getWih;
- getDwih;
- getWho;
- getDwho;

-(float) getEps;
-(float) getAlpha;
-(int)   getRandomOrderInLearning;
-(int)   getLongTermLearningInCT_OnlyWithCompleteTrainingSet;
-(int)   getUseOutputsAsTargetsInCT_RelearningScheme;

-(int) getInitDone;

@end

