// **********************************
// from basic code to apps: keep this file unchanged
// (this warning comes from bp-ct-1.1, i.e the original application containing
// this file)
// the file is modified here to use an ad hoc random distribution, the
// used var and the book address
// **********************************

// BPCTInterface.h

// This is the basis of each agent interface; the adaptation to each speficic
// agent type are contained exclusively in specific interface objects,
// which inherit from this one (as an example, in the basic code distribution,
// we have SpecificInterface.h and .m)

#import <objectbase/SwarmObject.h>
#import "Matrix.h"
#import "BPCTDataWarehouse.h"
#import "Book.h"

#import <math.h>   // to be used - if necessary - to generate inputs and
                   // targets in CT scheme, so in a specific interface

#import <random.h> // as above

#import <collections.h> // to use lists and indexes - if necessary - in
                        // the specific interface objects inheriting
                        // from this one

@interface BPCTInterface: SwarmObject
{
  int number, patternNumberInVerificationSet, inputNodeNumber, used;
  Matrix * outputVerificationMatrix, * targetVerificationMatrix,
         * dataVerificationMatrix, * dataTrainingMatrix,
         * minmax;
  BPCTDataWarehouse * myAgentDataWarehouse;
  Book * oneBook;
  id <UniformIntegerDist> myUniformIntRand;

  int useEO_EP;
  float eO_EPDelta;

}

- createEnd;

- setBook: b;

- setMyUniformIntRand: u;
- setDataWarehouse: dw;
- setUseEO_EP: (int) eo;
- setEO_EPDelta: (float) eod;
- setAgentNumber: (int) n;

- (int) getAgentNumber;

- initialize;
- setCT_Inputs;
- setCT_Targets;
- setUsed: (int) u;

@end
