// **********************************
// from basic code to apps: keep this file unchanged
// (this warning comes from bp-ct-1.1, i.e the original application containing it)
// here the file is modified to use a ad hoc random distribution
// **********************************

// BPCTRuleMaker.h 

#import <objectbase/SwarmObject.h>
#import <random.h>
#import "Matrix.h"
#import "MatrixMult.h"
#import "VectorTransFunc.h"
#import "BPCTDataWarehouse.h"

@interface BPCTRuleMaker: SwarmObject
{
   BPCTDataWarehouse * agentDataWarehouse;
   Matrix * dataTrainingMatrix, * minmax, * outputTrainingMatrix,
          * targetTrainingMatrix,
       * wih, * dwih, * who, * dwho,
       * inputLayer, * hiddenLayer, * outputLayer, * deltaOut,
       * hiddenLayerTransFuncDerivatives, * outputLayerTransFuncDerivatives;
   int     inputNodeNumber, inputNodeNumber1,
           hiddenNodeNumber, hiddenNodeNumber1,
           outputNodeNumber, patternNumberInTrainingSet,
           epochNumberInEachTrainingCycle,
           longTermLearningInCT_OnlyWithCompleteTrainingSet,
           useOutputsAsTargetsInCT_RelearningScheme;
   float eps, alpha, backPropagationError, proportionalError;
   int * p, usingRandomOrderInLearning;
   MatrixMult * matrixMult;
   VectorTransFunc * vectorTransFunc;
   id <UniformIntegerDist> myUniformIntRand;

}

- createEnd;
- setMyUniformIntRand: u;
- setMatrixMult: mM;
- setVectorTransFunc: vtf;
- adaptRulesToInputOutputValuesInDataWarehouse: agentDW;

-(float) getBackPropagationErrorInTrainingSet;
-(float) getProportionalErrorInTrainingSet;


@end
