// BasicSumAgent.m

#import "BasicSumAgent.h"
#import "Book.h"  // this is placed here to avoid a circular call


@implementation BasicSumAgent

  // we set the agent number
- setNumber: (int) n
{
  number = n;
  return self;
}

  // the address of the eventsGenerator
- setEventGenerator: eg
{
  eventGenerator=eg;
  return self;
}

  // we set the Book number
- setBookNumber: (int) m
{
  bookNumber = m;
  return self;
}

  // we set the Book
- setBook: b
{
  oneBook=b;
  return self;
}

- setAsymmetricBuySellProb: (float) p
{
  asymmetricBuySellProb=p;
  return self;
}

  // the address of the book of the market
- setBookArrayIndex: i
{
  bookArrayIndex = i;
  return self;
}

/*van - setForecastingAgentArrayIndex: i
{
  forecastingAgentArrayIndex = i;
  return self;
}
van*/

  // how many orders are we placing at each time?
- setMaxOrderQuantity: (int) m
{
  maxOrderQuantity=m;
  return self;
}

  // max number of orders for each agent (humans, arbitrageur, ecc.)
- setMaxOrderQuantity2: (int) m
{
  maxOrderQuantity2=m;
  return self;
}


  // this is a toggle: print / don't print
- setPrinting: (int) p
{
  printing=p;
  return self;
}

  // this is a toggle: delay / don't delay (for random agent)
- setDelay: (int) d
{
  delay=d;
  return self;
}



- createEnd
{
   [super createEnd];
   // initialize
   executedPriceCount=0;

   // keeping data for accounting reasons
   executedPrices=[Matrix2 createBegin: [self getZone]];
   [executedPrices setDimensionRows: maxOrderQuantity2 Cols: 2
                                                      Code: 1000+number];
   executedPrices=[executedPrices createEnd];

   liquidityQuantity=0;
   shareQuantity=0;
   shareValueAtMeanDailyPrice=0;
   agentWealthAtMeanDailyPrice=0;

   return self;
}


- (float) getPrice2: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     price = [aBook  getPrice];
     return price;
}

- (float) getMeanPrice: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     price = [aBook  getMeanPrice];
     return price;
}

- setOrderBeforeOpeningFromAgent2: (int) n ofAgent: (int) m atPrice: (float) p
{
     number = m;
     price = p;
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     [aBook setOrderBeforeOpeningFromAgent: number atPrice: price];
     return self;
}

- setOrderFromAgent2: (int) n ofAgent: (int) m atPrice: (float) p
{
     number = m;
     price = p;
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     [aBook setOrderFromAgent: number atPrice: price];
     return self;
}


- actPrepare
{
	int i;
    // clearing executedPrices
       executedPriceCount=0;
    // clearing control
       actingAtTheTime=0;
    actingBeforeOpening=0;
    for (i=0;i<maxOrderQuantity2;i++) [executedPrices R:i C:0 setFrom:0];

	return self;
}


- act0  // defined for compatibility reasons with current agent
{
  return self;
}

- act1  // defined for compatibility reasons with current agent
{
  return self;
}


- setConfirmationOfExecutedPrice: (float) p inBook: (int) m
{
  [executedPrices R: executedPriceCount C: 0 setFrom: p];
  [executedPrices R: executedPriceCount C: 1 setFrom: m];
  if(p!=0)++executedPriceCount;
  return self;
}

- orderConfirmationFrom: (int) theBookNumber atPrice:(float) price
{
	return self;
}

  // accounting
- act2
{
  float mP, q;
  int i,k;

  shareValueAtMeanDailyPrice=0;

  // accounting operation and display of
  // a message about the operation eventually done: if price is not zero
  // we have been buyer (executedPrice>0) or seller (executedPrice<0)

  if((printing==4)||(printing==1))
   for(i=0;i<executedPriceCount;i++)
   printf("I'm agent #%3d and the book number %3f told me: %7.4f\n",
                                   number,[executedPrices R:i C:1],[executedPrices R:i C:0]);
  mP=0;

  for (k=1;k<=bookNumber;k++){
   //float mP;
   mP=[self getMeanPrice:k];
   // quantity of shares
   q=0;

   for (i=0;i<executedPriceCount;i++)
   {
   if([executedPrices R:i C:1]==k) {
   	if([executedPrices R:i C:0]>0)q++;
   	if([executedPrices R:i C:0]<0)q--;
   }}

   shareQuantityVector[k] += q;
   shareQuantity += q;

   shareValueAtMeanDailyPrice += shareQuantityVector[k]*mP;
                                        // meanPrice at the end of each "day"
  }

   // we have CT agent for each book, so every agent operates only on a single book.
   meanOperatingPrice=0; // used in CT
   for (i=0;i<executedPriceCount;i++)
     {
       liquidityQuantity  -= [executedPrices R:i C:0];
       meanOperatingPrice += fabs([executedPrices R:i C:0]);
     }

   if(executedPriceCount != 0) meanOperatingPrice/=executedPriceCount;
   else meanOperatingPrice=mP;

   if((printing==4)||(printing==1))
   printf("I'm agent #%3d and the meanOperatingPrice is: %7.4f\n",
                                   number,meanOperatingPrice);

   agentWealthAtMeanDailyPrice=shareValueAtMeanDailyPrice+liquidityQuantity;
   return self;
}

- getProbe
{
  CREATE_ARCHIVED_PROBE_DISPLAY (self);
  return self;
}

- (float) getWealthAtMeanDailyPrice
{
  return agentWealthAtMeanDailyPrice;
}

- (int) getRandomBookNumber //: (int) randomBookNumber
{
  int randomBookNumber;
  randomBookNumber=[uniformIntRand getIntegerWithMin: 1 withMax: bookNumber];
  return randomBookNumber;
}


@end











