// Book.h

#import <objectbase/SwarmObject.h>
#import <collections.h>
#import "Matrix2.h"
#import "IndexCalculator.h"

@interface Book: SwarmObject
{

  id <Index> agentArrayIndex;
  Matrix2 * sellOrderStorehouse, * buyOrderStorehouse, * meanPriceHistory,
          * localHistory,* priceVolumesHistory,* quantityVolumesHistory,
          * auctionMatrix;
  int theBookNumber,sellOrderNumber, buyOrderNumber, maxOrderQuantity,
      agentNumber, printing, meanPriceHistoryLength, localHistoryLength,
      nAheadForecasting, quantityVolumes,priceVolumesHistoryLength,
     quantityVolumesHistoryLength, firstPrice, continuosMarket,acceptedOrder,
     futureBook,minimumExecutableOrders,
     executableOrders,surelyExecutableOrders,potentialBalanceness,balanceness,insertableInAuction, maxSurelyExecutableOrders, minBalanceness, auctionPriceRow;
  float price, executedPrice, meanPrice, currentMeanPrice,
        previousClosingPrice, priceVolumes, openingPrice, highPrice,closingPrice,
        lowPrice, oldPrice, indexValue,
        buyPrice,nextBuyPrice, controlPrice, sellPrice, nextSellPrice, nearestControlPrice, auctionPrice;
  int count;
  IndexCalculator * indexCalculator;

}

- createEnd;

- setAgentArrayIndex: i;
- setIndexCalculator: i;
- setAgentNumber: (int) n;
- setMaxOrderQuantity: (int) m;
- setMeanPriceHistoryLength: (int) l;
- setPriceVolumesHistoryLength: (int) l;
- setQuantityVolumesHistoryLength: (int) l;
- setLocalHistoryLength: (int) l;
- setPrinting: (int) p;
- setNumber: (int) n;
- setContinuosMarket: (int) n;
- setMeanPrice;
- setFutureBook: (int) fb;
- (float) auction;
- openingAuction;
- closingAuction;
- printControlPrice;
- printPrices: (int) n atPrice: (float) p;

- setClean;
- setOrderBeforeOpeningFromAgent: (int) n atPrice: (float) p;
- setOrderFromAgent: (int) n atPrice: (float) p;
- setNAheadForecasting: (int) na;

- (float) getPrice;
- (float) getPreviousClosingPrice;
- (float) getMeanPrice;
- (float) getLaggedMeanPrice: (int) lag; // the methods
                                         // 'getLaggedMeanPrice: 1' and
                                         // 'getMeanPrice give the same
                                         // result
- (float) getMeanPriceIndex;
- (int) getLocalHistory; // the method returns
                         //                     a positive int if locally
                         // see localHistoryLength) the # of buying decisions
                         // is greater than the # of selling decisions
                         //                     a negative int in the
                         // opposite case
- (float) getSellOrderNumber;
- (float) getBuyOrderNumber;
- (float) getAskPrice;
- (float) getBidPrice;

- (float) getLowPrice;
- (float) getHighPrice;
- (float) getOpeningPrice;
- (float) getClosingPrice;

// Volumes of each day

- (int) getQuantityVolumes;
- (float) getPriceVolumes;

- (int) getAcceptedOrder;


@end
