// EventGenerator.m                                        

#import "EventGenerator.h"
//#import "ModelSwarm.h"
//#import "AvatarAgent.h"


@implementation EventGenerator

-setStart: (int) s
{
  eventState = s;
  return self;
}



-setMyNormalDistRand: u
{
  myNormalDistRand = u;
  return self;
}

-setEventChangeProbability: (float) ecp
{
  eventChangeProbability = ecp;
  return self;
}

- setEventType: (int) et
{
  eventType = et;
  return self;
}

// we set the agent list
- setAvatarAgentList: l
{
   avatarAgentList = l;
   return self;
}

- (float) getEventState
{
  return eventState;
}

- setEventState
{
  
  // variance of Normal Random Distribution
  variance=0.15;
  // first flex point 
  firstFlex=-1*sqrt(variance);  
  // second flex point 
  secondFlex=sqrt(variance);
  
  //It evaluates the possibility to change state and event 
  changeState = 0;
  if ((float) [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0] < eventChangeProbability)
      changeState = 1;
  
  changeEvent = 0;
  if ((float) [uniformDblRand getDoubleWithMin: -1 withMax: +1] > 0)
      changeEvent = 1;

  //Analyze all case
  if (changeState==1)
  {
  	if (eventState!=0)
	{
		if (changeEvent==1)
		{
		    if (eventType==1)
		    {
		      //evaluate the intensity of the variable new event
		      eventState = [myNormalDistRand getSampleWithMean: 0.0 withVariance: variance];
		      if (eventState<firstFlex){[avatarAgentList  forEach:M(communicateEvent1)];}
		      else if ((eventState>firstFlex)&&(eventState<0)){[avatarAgentList  forEach:M(communicateEvent2)];}
		      else if ((eventState<secondFlex)&&(eventState>0)){[avatarAgentList  forEach:M(communicateEvent3)];}
                      else{[avatarAgentList  forEach:M(communicateEvent4)];}
                     
		      
		    }
		    else
		    {
		      //evaluate the intensity of the fixed new event 
		      eventState = [uniformIntRand getIntegerWithMin: -1 withMax: +1];
		      if (eventState<-0.5){[avatarAgentList  forEach:M(communicateEvent1)];}
		      else if ((eventState>=-0.5)&&(eventState<0)){[avatarAgentList  forEach:M(communicateEvent2)];}
		      else if ((eventState<=0.5)&&(eventState>0)){[avatarAgentList  forEach:M(communicateEvent3)];}
		      else{[avatarAgentList  forEach:M(communicateEvent4)];}	
		    }
		}
		else
		{
			eventState=0;
		}
	}
	else
	{
	    if (eventType==1)
	    {
	      //evaluate the intensity of the variable new event
	      eventState = [myNormalDistRand getSampleWithMean: 0.0 withVariance: variance];
	      if (eventState<firstFlex){[avatarAgentList  forEach:M(communicateEvent1)];}
	      else if ((eventState>firstFlex)&&(eventState<0)){[avatarAgentList  forEach:M(communicateEvent2)];}
	      else if ((eventState<secondFlex)&&(eventState>0)){[avatarAgentList  forEach:M(communicateEvent3)];}
              else{[avatarAgentList  forEach:M(communicateEvent4)];}
	    }
	    else
	    {
	      //evaluate the intensity of the fixed new event 
	      eventState = [uniformIntRand getIntegerWithMin: -1 withMax: +1];
	      if (eventState<-0.5){[avatarAgentList  forEach:M(communicateEvent1)];}
	      else if ((eventState>=-0.5)&&(eventState<0)){[avatarAgentList  forEach:M(communicateEvent2)];}
	      else if ((eventState<=0.5)&&(eventState>0)){[avatarAgentList  forEach:M(communicateEvent3)];}
	      else{[avatarAgentList  forEach:M(communicateEvent4)];}	      
	    }
		
	}
  }

  return self;
}

- createEnd
{
   [super createEnd];
   return self;
}

@end
