// EventRuleMaster.m                                        

#import "EventRuleMaster.h"

@implementation EventRuleMaster


- (float) getPriceBeforeOpening: (float) lastPrice withEventState: (float) eventState withBuySellP: (float) p
{
  //Choice to act before opening
  if (eventAgentChoiceToActBeforeOpening == 1)
  {
  	if ((float) eventState>1 || (float) eventState<-1)
  	{
  		eventCoefficient=1;
	}
  	if ((float) eventState<=1 && (float) eventState>=0)
  	{
  		eventCoefficient=eventState;
  	}
  	if ((float) eventState>=(-1) && (float) eventState<0)
  	{
  		eventCoefficient=-eventState;
  	}

	if (eventCoefficient < (float) [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0])
   	return 0.0;
  	else return [self getPrice: lastPrice withEventState: eventState withBuySellP: p];
  }
  //Due to act before opening if eventState different from zero
  else
  {
	if (eventState == 0)
	return 0.0;
	else return [self getPrice: lastPrice withEventState: eventState withBuySellP: p];
  }
}

- (float) getPrice: (float) lastPrice withEventState: (float) eventState withBuySellP: (float) p
{
  //positive event -> buyer
  if ((float) eventState>0)
  {
     price = lastPrice * (float)
		 [uniformDblRand getDoubleWithMin: 1
                   	              withMax: 1 + (eventState*eventSensibility)];

     choice=1;
  }

  //negative event -> seller
  if ((float) eventState<0)
  {
     price = lastPrice * (float)
             [uniformDblRand getDoubleWithMin: 1 + (eventState*eventSensibility)
     	                                withMax: 1];

     choice=-1;
  }

  //no event active -> random
  if ((float) eventState==0)
  {
    price = lastPrice * (float)
        [uniformDblRand getDoubleWithMin: minCorrectingCoeff + asymmetricRange
                                 withMax: maxCorrectingCoeff + asymmetricRange];

    choice=1; // buy with probability p
    if ((float) [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0] > p)
    choice=-1;// sell
  }

  return choice*price;

}

@end



