// ForecastingAgent.m                                        

// this file contains a lot of lines of the the DataWarehouse.m file of
// bp-ct application

#import "ForecastingAgent.h"
#import "ModelSwarm.h"
#import "SimpleANNRuleMaster.h"

  // function

void initANN(int inputNodeNumber1, int hiddenNodeNumber, 
             int hiddenNodeNumber1, int outputNodeNumber, float weightRange,
             id wih, id who, id dwih, id dwho, id myUniformDblRand)
{
  int i, j;

   // Initialization of the neural network weights
 
   for (i=0; i< hiddenNodeNumber;i++)
   for (j=0; j< inputNodeNumber1;j++)
   [wih R: i C: j setFrom: (float) [myUniformDblRand
                                       getDoubleWithMin: -weightRange
                                                withMax:  weightRange]];
   for (i=0; i< outputNodeNumber;i++)
   for (j=0; j< hiddenNodeNumber1;j++)
   [who R: i C: j setFrom: (float) [myUniformDblRand
                                       getDoubleWithMin: -weightRange
                                                withMax:  weightRange]];
   // putting zeros in dw?? matrixes

   for (i=0; i< hiddenNodeNumber;i++)
   for (j=0; j< inputNodeNumber1;j++)
   [dwih R: i C: j setFrom: 0.0];
   for (i=0; i< outputNodeNumber;i++)
   for (j=0; j< hiddenNodeNumber1;j++)
   [dwho R: i C: j setFrom: 0.0];

   return;
}

@implementation ForecastingAgent

  // we set the agent number
- setNumber: (int) n
{
  number = n;
  return self;
}


- setMyUniformDblRand: u
{
  myUniformDblRand = u;
  return self;
}

- setDataWindowLength: (int) dwl andNAheadForecasting: (int) n
                                 andForecastingTrainingSetLength: (int) tsl
                    andEpochNumberInEachForecastingTrainingCycle: (int) en
                    andLearningProcessEveryNDays: (int) nd
                    andCleanForecastingANNEveryMgtemNDays: (int) md
                    andForecastHistoryLength: (int) hl
{
  dataWindowLength = dwl;
  nAheadForecasting = n;
  forecastingTrainingSetLength = tsl;
  epochNumberInEachForecastingTrainingCycle = en;
  learningProcessEveryNDays = nd;
  cleanForecastingANNEveryMgtemNDays = md;
  forecastHistoryLength = hl; // set equal to meanPriceHistoryLength

  return self;
}
  // this is a toggle: print / don't print
- setPrinting: (int) p
{
  printing=p;
  return self;
}

  // the address of the book of the market
- setBook: b
{
  oneBook=b;
  return self;
}

- setModelSwarmAddress: m              // see the comment in step method
{
  modelSwarmAddress = m;
  return self;
}

- setSimpleANNRuleMasterAddress: r     // see the comment in step method
{
  simpleANNRuleMasterAddress = r;
  return self;
}

- createEnd
{
  int i;
   [super createEnd];

//  CREATE_ARCHIVED_PROBE_DISPLAY (self);
  // while debugging, right click on a matrix2 label, open probe (newly
  // right clicking on the box Matrix2) and execute 'print': the matrix
  // content will appear in the terminal

  learningProcessTrue = 0; // used to start the forward step in ANN

  weightRange = 0.3;
  eps         = 0.6;
  alpha       = 0.9;
  usingRandomOrderInLearning = 1;

   inputNodeNumber1=dataWindowLength+1;
   hiddenNodeNumber=(inputNodeNumber1-1)/2; // a drastic solution
                                            // but we can modify it
                                            // using the forecasting.setup
                                            // file below
   outputNodeNumber=1;
  // we can modify here: weigthRange, eps, alpha, usingRandomOrderInLearning
  // _and_ hiddenNodeNumber
  [ObjectLoader load: self fromFileNamed: "forecasting.setup"];
   hiddenNodeNumber1=hiddenNodeNumber+1;

   forecastingTrainingSet=[Matrix2 createBegin: [self getZone]];
   [forecastingTrainingSet setDimensionRows: forecastingTrainingSetLength 
            Cols: dataWindowLength+1 Code: 11111];  // +1 to save the
                                                    // the day ahead (target)
   forecastingTrainingSet=[forecastingTrainingSet createEnd];

   forecastingSet=[Matrix2 createBegin: [self getZone]];
   [forecastingSet setDimensionRows: 1 
            Cols: dataWindowLength   Code: 11112];
   forecastingSet=[forecastingSet createEnd];

   forecastHistory=[Matrix2 createBegin: [self getZone]];
   [forecastHistory setDimensionRows: forecastHistoryLength
                                  Cols: 1 Code: 11333];
   forecastHistory=[forecastHistory createEnd];
   // indexes will be stored by rows; now we fill all the r. with
   // the neutral "1" index
   for (i=0;i<=forecastHistoryLength-1;i++)
               [forecastHistory R:i C:0 setFrom: 1.0];

   outputTrainingMatrix= [Matrix2 createBegin: [self getZone]];
   [outputTrainingMatrix setDimensionRows:  forecastingTrainingSetLength 
                                     Cols: outputNodeNumber Code: 11121];
   outputTrainingMatrix = [outputTrainingMatrix createEnd];

   targetTrainingMatrix= [Matrix2 createBegin: [self getZone]];
   [targetTrainingMatrix setDimensionRows:  forecastingTrainingSetLength
                              Cols: outputNodeNumber Code: 11122];
   targetTrainingMatrix = [targetTrainingMatrix createEnd];

   minmax=[Matrix2 createBegin: [self getZone]];
   [minmax setDimensionRows: dataWindowLength + 1
                       Cols: 4      Code: 11113];
   minmax=[minmax createEnd];

   // we initialize minmax matrix with the hypotesis that - being our data
   // (see below) indexes - a "good" range is 0.3-1.7 
   for (i=0;i<dataWindowLength+1;i++)
    {
      [minmax R: i C: 0 setFrom: 0.1];
      [minmax R: i C: 1 setFrom: 1.9];
      [minmax R: i C: 2 setFrom: 0.0];
      [minmax R: i C: 3 setFrom: 1.0];
      if(i==dataWindowLength){
                              [minmax R: i C: 2 setFrom: 0.1];
                              [minmax R: i C: 3 setFrom: 0.9];
                             }
    }

   // we create internal matrixes, with input and hidden bias
   // 'wih' means weights from the input  layer to the hidden one
   // 'who' means weights from the hiddel layer to the output one
   // the 'd' in 'dwih' or 'dwho' stays for difference

   // rows=hiddenNodeNumber cols=inputNodeNumber1
   wih=[Matrix2 createBegin: [self getZone]];
   [wih setDimensionRows: hiddenNodeNumber Cols: inputNodeNumber1
                                           Code: 20008];
   wih=[wih createEnd];

   dwih=[Matrix2 createBegin: [self getZone]];
   [dwih setDimensionRows: hiddenNodeNumber Cols: inputNodeNumber1
                                            Code: 20009];
   dwih=[dwih createEnd];

   // rows=outputNodeNumber cols=hiddenNodeNumber1
   who=[Matrix2 createBegin: [self getZone]];
   [who setDimensionRows: outputNodeNumber Cols: hiddenNodeNumber1
                                           Code: 20010];
   who=[who createEnd];

   dwho=[Matrix2 createBegin: [self getZone]];
   [dwho setDimensionRows: outputNodeNumber Cols: hiddenNodeNumber1
                                            Code: 20011];
   dwho=[dwho createEnd];

   // Initialization of the neural network weights
   initANN(inputNodeNumber1, hiddenNodeNumber, 
           hiddenNodeNumber1, outputNodeNumber, weightRange,
           wih, who, dwih, dwho, myUniformDblRand);
 
   // creation of internal vectors
   inputLayer=[Matrix2 createBegin: [self getZone]];
   [inputLayer setDimension: inputNodeNumber1 Code: 20012];
   inputLayer=[inputLayer createEnd];

   hiddenLayer=[Matrix2 createBegin: [self getZone]];
   [hiddenLayer setDimension: hiddenNodeNumber1 Code: 20013];
   hiddenLayer=[hiddenLayer createEnd];

  hiddenLayerTransFuncDerivatives=[Matrix2 createBegin: [self getZone]];
  [hiddenLayerTransFuncDerivatives setDimension: hiddenNodeNumber1 
                                                          Code: 20131];
  hiddenLayerTransFuncDerivatives=[hiddenLayerTransFuncDerivatives createEnd];

   outputLayer=[Matrix2 createBegin: [self getZone]];
   [outputLayer setDimension: outputNodeNumber Code: 20014];
   outputLayer=[outputLayer createEnd];

  outputLayerTransFuncDerivatives=[Matrix2 createBegin: [self getZone]];
  [outputLayerTransFuncDerivatives setDimension: outputNodeNumber 
                                                           Code: 20141];
  outputLayerTransFuncDerivatives=[outputLayerTransFuncDerivatives createEnd];

   deltaOut=[Matrix2 createBegin: [self getZone]];
   [deltaOut setDimension: outputNodeNumber Code: 20015];
   deltaOut=[deltaOut createEnd];

   return self;
}

- getForecastingSet
{
  return forecastingSet;
}

- getForecastingTrainingSet
{
  return forecastingTrainingSet;
}

- getMinmax
{
  return minmax;
}

- (int) getDataWindowLength
{
  return dataWindowLength;
}

- (int) getHiddenNodeNumber
{
  return hiddenNodeNumber;
}

- (int) getForecastingTrainingSetLength
{
  return forecastingTrainingSetLength;
}

- (int) getEpochNumberInEachForecastingTrainingCycle
{
  return epochNumberInEachForecastingTrainingCycle;
}

- getOutputTrainingMatrix{return outputTrainingMatrix;}
- getTargetTrainingMatrix{return targetTrainingMatrix;}

- getInputLayer{return inputLayer;}
- getHiddenLayer{return hiddenLayer;}
- getHiddenLayerTransFuncDerivatives{return hiddenLayerTransFuncDerivatives;}
- getOutputLayer{return outputLayer;}
- getOutputLayerTransFuncDerivatives{return outputLayerTransFuncDerivatives;}
- getDeltaOut{return deltaOut;}

- getWih{return wih;}
- getDwih{return dwih;}
- getWho{return who;}
- getDwho{return dwho;}

-(float) getEps{return eps;}
-(float) getAlpha{return alpha;}
-(int) getRandomOrderInLearning{return usingRandomOrderInLearning;}

- step
{
  ModelSwarm * modelSwarm;                   // here to avoid circular calls
  SimpleANNRuleMaster * simpleANNRuleMaster; // " " "
  int i,j;

  modelSwarm=modelSwarmAddress;                  // so we use the syntactic
  simpleANNRuleMaster=simpleANNRuleMasterAddress;//cheks of the methods known
                                                 // by the classes above

  currentDay=[modelSwarm getCurrentDay];

  // shifting down the rows of the matrix to modify continously the
  // the training set (see Matrix2.h to understand the 'pushRowsDown' method)

  [forecastingTrainingSet pushRowsDown];

  // copying the last mean price and then the lagged values (as return indexes)

  // NB about lagged values and return indexes: data are treated as
  // return indexes to eliminate volatility in mean and variance; due to
  // the delay among the nAhead forecasted day and the input data and
  // the necessity of evalutating the return indexes, we need here to use
  // dataWindowLength+2*nAheadForecasting data

  // NB to use my ANN routines values must be stored as internal values,
  // i.e. applying scaling on the basis of the minmax matrix
  [forecastingTrainingSet R:0 C: dataWindowLength setFrom:
			    [oneBook getLaggedMeanPrice: 1]/
                            [oneBook getLaggedMeanPrice: 1+nAheadForecasting]
                             asExternalValueUsing: minmax withShift: 0];
  for (i=1+nAheadForecasting;i<=dataWindowLength+nAheadForecasting;i++)
      [forecastingTrainingSet R:0 C: dataWindowLength-i+nAheadForecasting 
                   setFrom: [oneBook getLaggedMeanPrice: i]/
			    [oneBook getLaggedMeanPrice: i+nAheadForecasting]
                             asExternalValueUsing: minmax withShift: 0];

  // creating the forecasting set
  for (i=1;i<=dataWindowLength;i++)  
      [forecastingSet R:0 C: dataWindowLength-i 
                   setFrom: [oneBook getLaggedMeanPrice: i]/
			    [oneBook getLaggedMeanPrice: i+nAheadForecasting]
                             asExternalValueUsing: minmax withShift: 0];

  if(printing==2){
                  printf("Current day = %d\n",currentDay);
                  for (i=0;i<forecastingTrainingSetLength;i++)
                   {
		     for (j=0;j<dataWindowLength+1;j++)
		       printf("%5.3f ",[forecastingTrainingSet R:i C: j]);
                       printf("\n");
                   } 
                     for (j=0;j<dataWindowLength;j++)
		       printf("%5.3f ",[forecastingSet R:0 C: j]);
                       printf("\n");
                  }

  // --- ANN cleaning

  if(currentDay>forecastingTrainingSetLength &&
     currentDay%cleanForecastingANNEveryMgtemNDays==0)
    initANN(inputNodeNumber1, hiddenNodeNumber, 
            hiddenNodeNumber1, outputNodeNumber, weightRange,
            wih, who, dwih, dwho, myUniformDblRand);

  // --- ANN learning and forwarding steps

  // every N days
  if(currentDay>forecastingTrainingSetLength &&
     currentDay%learningProcessEveryNDays==0)
  {
  [simpleANNRuleMaster 
                applyRulesToInputOutputValuesInForecastingTrainingSet: self];
  learningProcessTrue=1;
  }

  // each day  
  if (learningProcessTrue==1)
  {
   [simpleANNRuleMaster applyRulesToInputValuesInForecastingSet: self];
   index=[simpleANNRuleMaster getOutput];
  }
  else index=1;

  if(printing==3)printf("Day %d, forecast %5.2f\n",currentDay,index);
  // forecastHistory in row 0 contains the t-1 forecast (done in t, but using
  //                                                     t-1 data, for day
  //                                                     t+N-1
  //                 in row 1 contains the t-2 forecast
  //                 etc.
  for (i=forecastHistoryLength-2;i>=0;i--)
                    [forecastHistory R:i+1 C:0 setFrom:
                                      [forecastHistory R:i C:0]];
  [forecastHistory R:0 C:0 setFrom: index];


  return self;
}

- (float) getBackPropagationErrorInTrainingSet
{
  SimpleANNRuleMaster * simpleANNRuleMaster;

  simpleANNRuleMaster=simpleANNRuleMasterAddress;
  return [simpleANNRuleMaster getBackPropagationErrorInTrainingSet];
}

- (float) getProportionalErrorInTrainingSet
{
  SimpleANNRuleMaster * simpleANNRuleMaster;

  simpleANNRuleMaster=simpleANNRuleMasterAddress;
  return [simpleANNRuleMaster getProportionalErrorInTrainingSet];
}

- (float) getPastEstimateIndex // the forecast of day t-1 based on t-N-1 data
                               // (made in t-N)
{
  return [forecastHistory R: nAheadForecasting C: 0];
}

- (float) getCurrentEstimateIndex // the forecast of day t+N-1 based on t-1 data
                                  // (made in t), expressed as return index
{
  return [forecastHistory R: 0 C: 0];
}

@end
