// IndexCalculator.m

#import "IndexCalculator.h"
#import "Book.h"

@implementation IndexCalculator

 // we set the Book number
- setBookNumber: (int) m
{
  bookNumber = m;
  return self;
}

  // the address of the book of the market
- setBookArrayIndex: i
{
  bookArrayIndex = i;
  return self;
}

  // this is a toggle: print / don't print
- setPrinting: (int) p
{
  printing=p;
  return self;
}


- (float) getPrice: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     price = [aBook  getPrice];
     return price;
}

- (float) getOpeningPrice: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     price = [aBook  getOpeningPrice];
     return price;
}

- (float) getClosingPrice: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     price = [aBook  getClosingPrice];
     return price;
}

- (float) getLowPrice: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     price = [aBook  getLowPrice];
     return price;
}

- (float) getHighPrice: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     price = [aBook  getHighPrice];
     return price;
}

- (float) getQuantityVolumes: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     price = [aBook  getQuantityVolumes];
     return price;
}

- (int) getAcceptedOrder: (int) n
{
     Book * aBook;
     [bookArrayIndex setOffset: n-1];
     aBook=[bookArrayIndex get];
     acceptedOrder = [aBook  getAcceptedOrder];
     return acceptedOrder;
}


- createEnd
{
   [super createEnd];
   currentDay=0;
   return self;
}



- (float) getIndexValue
{

   int i;
   float sumOfPrice;
   sumOfPrice=0.0;

   for (i=1;i<bookNumber;i++)
    {
      sumOfPrice+=[self getPrice:i];
    }

   indexValue=sumOfPrice/(bookNumber-1);
   if(printing==1)printf("Theoric Index Value %9.5f\n",indexValue);
   return (float)  indexValue;

}

- ohlc
{
currentDay++;
   int i;

   for (i=1;i<=bookNumber;i++)
   {

      closingPrice=[self getClosingPrice:i];
      openingPrice=[self getOpeningPrice:i];
      highPrice=[self getHighPrice:i];
      lowPrice=[self getLowPrice:i];
      quantityVolume=[self getQuantityVolumes: i];

	  char  webdataFileName [40];
	  sprintf(webdataFileName,"bookohlc%d.dat",i);

	  FILE * pFile;

	  pFile = fopen (webdataFileName,"a");
	  if (pFile == NULL) {
		  perror("cannot open output file1");
	      return self;
	  }
	  fprintf(pFile,"%3d\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t%9.4f\t\n",currentDay,openingPrice,highPrice,lowPrice,closingPrice, quantityVolume);
	  fclose(pFile);

    }




	char  webdataFileName2 [40];
	sprintf(webdataFileName2,"acceptedorder.dat");

	FILE * ppFile;
	ppFile = fopen (webdataFileName2,"a");
	if (ppFile == NULL) {
		perror("cannot open output file1");
		return self;
	}

	fprintf(ppFile,"%3d\t",currentDay);

    for (i=1;i<=bookNumber;i++)
    {
	   acceptedOrder=[self getAcceptedOrder: i];
	   fprintf(ppFile,"%10d\t",acceptedOrder);
	}

	fprintf(ppFile,"\n");
	fclose(ppFile);


    return self;
}


@end
