// ObserverSwarm.h

#import "ModelSwarm.h"
#import "Book.h"
#import "ForecastingAgent.h"
#import "EventGenerator.h"
#import "IndexCalculator.h"

  //agentForge step 10b
#import "BPCTAgentA.h"
#import "BPCTAgentAInterface.h"
#import "BPCTAgentB.h"
#import "BPCTAgentBInterface.h"

#import <simtoolsgui/GUISwarm.h>
#import <analysis.h> // to use EZgraph


@interface ObserverSwarm: GUISwarm
{
  int displayFrequency;       // freq. of update in the
                              // Observer widgets
  int showPriceGraph, showBookGraph, showVolumesGraph, showAgentWealthGraph, showForecastingAgentGraph,
      displayPreviousDayMean, savePriceData, saveForecastingData,showEventsGraph,saveEventsData,
    saveBookData,saveVolumesData,saveAgentWealthData, bookNumber,

  //agentForge step 10c
      numberOfTheBPCTAgentA_ToBeObservedDirectly,
      saveBPCTAgentAData,
      numberOfTheBPCTAgentB_ToBeObservedDirectly,
      saveBPCTAgentBData,

      bPCTPatternNumberInVerificationSet;

  id displayActions;          // schedule data structures
  id displaySchedule;

  // agentForge step 10
  id <EZGraph> priceGraph, volumesGraph, bookGraph, eventsGraph,agentWealth, agentWealthGraph,
               forecastingAgentGraph, bPCTAgentA_Graph, bPCTAgentB_Graph;

  int stopAtDayNumber;

  ModelSwarm *modelSwarm;               // the Swarm containing our model
  Book * oneBook;
  IndexCalculator * indexCalculator;
  ForecastingAgent * oneForecastingAgent;
  EventGenerator * eventGenerator;


  //agentForge step 10d
  BPCTAgentA * agentA;
  BPCTAgentAInterface * agentAInterface;
  BPCTAgentB * agentB;
  BPCTAgentBInterface * agentBInterface;

}

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;

- checkToStop;

@end

