// Quota.m                                        

#import "Quota.h"

@implementation Quota

- createEnd
{ 

  id <ProbeMap> probeMap;

  [super createEnd];

  currentDay=0;
  tot=0;
  correctSigns=0;
  correctSignsG=0;
  totLocal=0;
  correctSignsLocal=0;
  correctSignsGLocal=0;

  probeMap = [EmptyProbeMap createBegin: [self getZone]];
  [probeMap setProbedClass: [self class]];
  probeMap = [probeMap createEnd];

  // add variables to be probed

  [probeMap addProbe: [probeLibrary getProbeForVariable: 
            "quotaOfCorrectSignsInForecastingFromANNCleaning"    
                                                  inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForVariable: 
            "quotaOfCorrectSignsInForecastingGFromANNCleaning"   
                                                  inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForVariable: 
            "quotaOfCorrectSignsInForecasting"    inClass: [self class]]];
  [probeMap addProbe: [probeLibrary getProbeForVariable: 
            "quotaOfCorrectSignsInForecastingG"   inClass: [self class]]];

  [probeLibrary setProbeMap: probeMap For: [self class]];

  CREATE_ARCHIVED_PROBE_DISPLAY (self);

  return self;
}

- setNumber: (int) n
{
  quotaNumber = n;
  return self;
}

- setForecastingAgent: f
{
  forecastingAgent=f;  
  return self;
}

- setBook: b
{
  theBook=b;
  return self;
}

- setCleanForecastingANNEveryMgtemNDays: (int) md
{
  cleanForecastingANNEveryMgtemNDays = md;
  return self;
}

- step
{
  currentDay++;
  if(currentDay%cleanForecastingANNEveryMgtemNDays==0)
  {
   totLocal=0;
   correctSignsLocal=0;
   correctSignsGLocal=0;   
  }

  p = [theBook getMeanPriceIndex];
  e = [forecastingAgent getPastEstimateIndex];

  // an estimate has been generated
  if (e != 1.0) 
  {
   tot++;
   totLocal++;
   if ((e>1 && p>1) || (e<1 && p<1)) 
   {
    correctSigns++;
    correctSignsLocal++;
    // more relevant cases
    if(p<=0.9 || p>=1.1){correctSignsG++;correctSignsGLocal++;}
   }

   quotaOfCorrectSignsInForecasting = correctSigns/tot;
   quotaOfCorrectSignsInForecastingG = correctSignsG/tot;
   quotaOfCorrectSignsInForecastingFromANNCleaning = 
                                                 correctSignsLocal/totLocal; 
   quotaOfCorrectSignsInForecastingGFromANNCleaning = 
                                                 correctSignsGLocal/totLocal; 
  }
  return self;
}

@end
