// RandomRuleMaster.m                                        

#import "RandomRuleMaster.h"

@implementation RandomRuleMaster


- (float) getPriceBeforeOpening: (float) lastPrice
          withBuySellP: (float) p
{
  if (agentProbToActBeforeOpening <
     (float) [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0])
   return 0.0;
  else return [self getPrice: lastPrice withBuySellP: p];
}

- (float) getPrice: (float) lastPrice withBuySellP: (float) p
{
  float price, choice;
  price = lastPrice * (float)
      [uniformDblRand getDoubleWithMin: minCorrectingCoeff + asymmetricRange
                               withMax: maxCorrectingCoeff + asymmetricRange];

  choice=1; // buy with probability p
  if ((float) [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0] > p)
  choice=-1;// sell


  // buying when the price glide below the floor price, with probability
  // agentProbToActBelowFloorP
  if (lastPrice<floorP){
  if (agentProbToActBelowFloorP > (float)
     [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0])
     {
     price=lastPrice;
     choice=1;
     }                 }


  return choice*price;
}

@end



