// **********************************
// This file is derived - with a lot of changes - from bp-ct package
// **********************************

// SimpleANNRuleMaker.h 

#import <objectbase/SwarmObject.h>
#import "Matrix2.h"
#import "MatrixMult.h"
#import "VectorTransFunc.h"
#import "ForecastingAgent.h"
#import <simtoolsgui/GUISwarm.h> // to use CREATE_ARCHIVED_PROBE_DISPLAY
#import <simtoolsgui.h>          // ""
#import <random.h>

@interface SimpleANNRuleMaker: SwarmObject
{
   ForecastingAgent * forecastingAgent;
   Matrix2 * forecastingTrainingSet,
           * minmax, * outputTrainingMatrix,
           * targetTrainingMatrix,
       * wih, * dwih, * who, * dwho,
       * inputLayer, * hiddenLayer, * outputLayer, * deltaOut,
       * hiddenLayerTransFuncDerivatives, * outputLayerTransFuncDerivatives;
   int     inputNodeNumber, inputNodeNumber1,
           hiddenNodeNumber, hiddenNodeNumber1,
           outputNodeNumber, patternNumberInTrainingSet,
           epochNumberInEachTrainingCycle;
   float eps, alpha, backPropagationError, proportionalError;
   int * p, usingRandomOrderInLearning;
   MatrixMult * matrixMult;
   VectorTransFunc * vectorTransFunc;
   id <UniformIntegerDist> myUniformIntRand;
}

- createEnd;
- setMatrixMult: mM;
- setVectorTransFunc: vtf;
- adaptRulesToInputOutputValuesInForecastingTrainingSet: forecastingAg;
- setMyUniformIntRand: u; // an ad hoc distribution, see comment in 
                          // modelSwarm.h and .m

-(float) getBackPropagationErrorInTrainingSet;
-(float) getProportionalErrorInTrainingSet;


@end
