// **********************************
// This file is derived - with a lot of changes - from bp-ct package
// **********************************

// SimpleANNRuleMaster.h 

#import <objectbase/SwarmObject.h>
#import "SimpleANNRuleMaker.h"
#import "Matrix2.h"
#import "MatrixMult.h"
#import "VectorTransFunc.h"
#import "SimpleANNRuleMaster.h"
#import "ForecastingAgent.h"
#import <simtoolsgui/GUISwarm.h> // to use CREATE_ARCHIVED_PROBE_DISPLAY
#import <simtoolsgui.h>          // ""

@interface SimpleANNRuleMaster: SwarmObject
{
   ForecastingAgent * forecastingAgent;
   int     inputNodeNumber, inputNodeNumber1,
           hiddenNodeNumber, hiddenNodeNumber1, outputNodeNumber;
   Matrix2 * forecastingSet,
           * wih, * dwih, * who, * dwho,
           * inputLayer, * hiddenLayer, * outputLayer, * minmax;
   float output;
   MatrixMult * matrixMult;
   VectorTransFunc * vectorTransFunc;

   SimpleANNRuleMaker * simpleANNRuleMaker;
}

- createEnd;

// tools
- setSimpleANNRuleMaker: rm;
- setMatrixMult: mM;
- setVectorTransFunc: vtf;

// neural network forward step
- applyRulesToInputValuesInForecastingSet: forecastingAg;
// neural network learning
- applyRulesToInputOutputValuesInForecastingTrainingSet: forecastingAgent;

// to return the result of the forward step in forecasting

-(float) getOutput;

// to return error measures

-(float) getBackPropagationErrorInTrainingSet;
-(float) getProportionalErrorInTrainingSet;

@end

