// **********************************
//  This file is derived - with a lot of changes - from bp-ct package
// **********************************

// SimpleANNRuleMaster.m                                        

#import "SimpleANNRuleMaster.h"
#import <math.h>

@implementation SimpleANNRuleMaster

- createEnd
{
   [super createEnd];

//  CREATE_ARCHIVED_PROBE_DISPLAY (self);
  // while debugging, right click on a matrix2 label, open probe (newly
  // right clicking on the box Matrix2) and execute 'print': the matrix
  // content will appear in the terminal

   return self;                        
}

- setSimpleANNRuleMaker: rm
{
  simpleANNRuleMaker=rm;
  return self;
}

- setMatrixMult: mM
{
  matrixMult=mM;
  return self;
}

- setVectorTransFunc: vts
{
  vectorTransFunc=vts;
  return self;
}

- applyRulesToInputValuesInForecastingSet: forecastingAg

  // forward step in a neural network y=f(B f(Ax)) where x and y are vectors,
  // A and B are matrixes and f is a tranformation function, here the
  // logistic one r(s)=(1+e^(-k*s))^-1

  // when introducing a constant value (the bias) as input and hidden node
  // (neuron)
  //            y=f(B f(Ax)) becomes
  //            y=f(B (1, f(A (1,x')')' )' )

{
   int j;

  forecastingAgent=forecastingAg;

  // the ruleMaster operates with the data stored in the forecastingAgent;
  // here we get the address or the arrays containing data; technically we are
  // only moving information about pointers or about array dimensions
  forecastingSet   = [forecastingAgent getForecastingSet];
  minmax=[forecastingAgent getMinmax];
  inputNodeNumber  = [forecastingAgent getDataWindowLength];
  inputNodeNumber1 = inputNodeNumber+1;
  hiddenNodeNumber = [forecastingAgent getHiddenNodeNumber];
  hiddenNodeNumber1= hiddenNodeNumber+1;
  outputNodeNumber = 1;

  wih = [forecastingAgent getWih];
  dwih= [forecastingAgent getDwih];
  who = [forecastingAgent getWho];
  dwho= [forecastingAgent getDwho];
  inputLayer  = [forecastingAgent getInputLayer];
  hiddenLayer = [forecastingAgent getHiddenLayer];
  outputLayer = [forecastingAgent getOutputLayer];


   // we introduce a forward calculus in the neural network; if we refer to
   // the simplified form y=f(b f(A x)) we have ->

   // building inputLayer                       -> to set x
   [inputLayer P: 0 setFrom: 1.]; // constant artificial input (bias)
   for (j=0;j<inputNodeNumber;j++)
     [inputLayer P: j+1 setFrom: [forecastingSet R: 0 C: j]];

   // building hiddenLayer                     -> (A x)
   [matrixMult m1: wih m2: inputLayer  to1: hiddenLayer];

   // applying transformation function         -> f(A x)
   [vectorTransFunc from1: hiddenLayer to1: hiddenLayer];

   // hidden bias
   [hiddenLayer P: 0 setFrom: 1.];

   // building output layer                    -> B f(A x)
   [matrixMult m1: who m2: hiddenLayer to: outputLayer];

   // applying transformation function         -> f(B f(A x))
   [vectorTransFunc from: outputLayer to: outputLayer];


   // output (as in bp-ct values in matrixes are in internal metrics,
   //         but this is a scalar containing a final result, 
   //         so we use it in external metrics)
   output = (([outputLayer P: 0] - [minmax R:inputNodeNumber C:2])
                                 /([minmax R:inputNodeNumber C:3]-
                                   [minmax R:inputNodeNumber C:2]) )
                                 *([minmax R:inputNodeNumber C:1]-
                                   [minmax R:inputNodeNumber C:0])+
                                   [minmax R:inputNodeNumber C:0];

   return self;
}

- applyRulesToInputOutputValuesInForecastingTrainingSet: forecastingAg

{
   // finally, we call the ruleMaker to learn from the trainingSet
   [simpleANNRuleMaker adaptRulesToInputOutputValuesInForecastingTrainingSet:
                                                            forecastingAg];
   return self;
}


-(float) getBackPropagationErrorInTrainingSet
{
  return [simpleANNRuleMaker getBackPropagationErrorInTrainingSet];
}

-(float) getProportionalErrorInTrainingSet
{
  return [simpleANNRuleMaker getProportionalErrorInTrainingSet];
}

  // this method returns the result of the forward step as external value
-(float) getOutput
{
  return output;
}

@end

