// StopLossAgent.m

#import "StopLossAgent.h"

@implementation StopLossAgent


  // our ruleMaster
- setRuleMaster: r
{
  ruleMaster=r;
  return self;
}

- setStopLossInterval: (int) i
{
  stopLossInterval=i;
  return self;
}

- setMaxLossRate: (float) r andCheckingIfShortOrLong: (int) sl
{
  maxLossRate=r;
  checkingIfShortOrLong=sl;
  return self;
}


  // Acting before opening
- act0
{
   float lastPrice, stopLossMeanPrice;
   int i;

   buySellSwitch=0.5;



   actingBeforeOpening=0;

   lastPrice=[oneBook getPrice];

   // the mean price in t-stopLossInterval
   stopLossMeanPrice=[oneBook getLaggedMeanPrice: stopLossInterval];


   // Asking the ruleMaster for a position (if the price is > 0 we are
   // buyer; if it is <0 we are seller; if it is =0 we do nothing
   // the ruleMaster uses in this case the probability of operating
   // before opening
   price=[ruleMaster getPriceBeforeOpening: lastPrice
		     withBuySellP: buySellSwitch
                     andStopLossMeanPrice: stopLossMeanPrice
                     andMaxLossRate: maxLossRate
                     andShareQuantity: (float) shareQuantity
                     andCheckingIfShortOrLong: (float) checkingIfShortOrLong];

   if (price!=0) actingBeforeOpening=1;

   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   // if price==0 oneBook is not recording it
   [oneBook setOrderBeforeOpeningFromAgent: number atPrice: price];

   return self;
}

  // acting in the market
- act1
{
   float lastPrice, stopLossMeanPrice;
   int i;

   buySellSwitch=0.5;

   // the agent has operated before opening
   if (actingBeforeOpening==1) return self;

   lastPrice=[oneBook getPrice];

   // Asking the ruleMaster for a position (if the price is > 0 we are
   // buyer; if it is <0 we are seller; if it is =0 we do nothing

   // the mean price in t-stopLossInterval
   stopLossMeanPrice=[oneBook getLaggedMeanPrice: stopLossInterval];


   price=[ruleMaster getPrice: lastPrice
                     withBuySellP: buySellSwitch
                     andStopLossMeanPrice: stopLossMeanPrice
                     andMaxLossRate: maxLossRate
                     andShareQuantity: shareQuantity
                     andCheckingIfShortOrLong: checkingIfShortOrLong];


   // how many orders?
   if (maxOrderQuantity==1) iMax=1;
    else iMax=[uniformIntRand getIntegerWithMin: 1 withMax: maxOrderQuantity];
   for (i=1;i<=iMax;i++)
   [oneBook setOrderFromAgent: number atPrice: price];

   return self;
}

@end










