// StopLossRuleMaster.m                                        

#import "StopLossRuleMaster.h"

@implementation StopLossRuleMaster

- createEnd
{
   [super createEnd];

   return self;                        
}

- (float) getPriceBeforeOpening: (float) lastPrice
          withBuySellP: (float) p
          andStopLossMeanPrice: (float) stopLossMeanPrice
          andMaxLossRate: (float) maxLossRate
          andShareQuantity: (float) shareQuantity
          andCheckingIfShortOrLong: (int) checkingIfShortOrLong
{
  if (agentProbToActBeforeOpening <
     (float) [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0])
   return 0.0;
   else return [self getPrice:  (float) lastPrice
          withBuySellP: (float) p
          andStopLossMeanPrice: (float) stopLossMeanPrice
          andMaxLossRate: (float) maxLossRate
          andShareQuantity: (float) shareQuantity
          andCheckingIfShortOrLong: (int) checkingIfShortOrLong];
}


- (float) getPrice:  (float) lastPrice
          withBuySellP: (float) p
          andStopLossMeanPrice: (float) stopLossMeanPrice
          andMaxLossRate: (float) maxLossRate
          andShareQuantity: (float) shareQuantity
          andCheckingIfShortOrLong: (int) checkingIfShortOrLong
{

  // the basic random choice
  float price, choice, stopLossChoice;
  price = lastPrice * (float)
      [uniformDblRand getDoubleWithMin: minCorrectingCoeff + asymmetricRange
                               withMax: maxCorrectingCoeff + asymmetricRange];

  choice=1; // buy with probability p
  if ((float) [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0] > p)
  choice=-1;// sell


  // buying when the price glide below the floor price, with probability
  // agentProbToActBelowFloorP
  if (lastPrice<floorP){
  if (agentProbToActBelowFloorP > (float)
     [uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0])
     {
     price=lastPrice;
     choice=1;
     }                 }


  // adopting stop loss, if any

  // case (i) not checking if the agent is short or long
  if (checkingIfShortOrLong==0)
  {
   stopLossChoice=0;
   if(lastPrice>=stopLossMeanPrice*(1+maxLossRate)) stopLossChoice= 1;
   if(lastPrice<=stopLossMeanPrice*(1-maxLossRate)) stopLossChoice=-1;
   if(stopLossChoice!=0)
   {
      price=lastPrice;
      choice=stopLossChoice;
   }
  }

  // case (ii) checking if the agent is short or long and using yesterday
  // share quantity as an indicator of being short or long
  if (checkingIfShortOrLong==1)
  {
    stopLossChoice=0; // if shareQuantity==0, stopLossChoice don't change
   // if "short"
   if(lastPrice>=stopLossMeanPrice*(1+maxLossRate)
      && shareQuantity<0) stopLossChoice= 1;
   // if "long"
   if(lastPrice<=stopLossMeanPrice*(1-maxLossRate)
      && shareQuantity>0) stopLossChoice=-1;

   if(stopLossChoice!=0)
   {
      price=lastPrice;
      choice=stopLossChoice;
   }
  }
  // the quantity of shares bought or sold is established in Agent.m
  // from 1 to maxOrderQuantity, regardless to the value of shareQuantity

  return choice*price;
}

@end









